/** returns boolean */
export declare type CallBackFilter<T> = (value: T, index?: number, collection?: T[]) => Promise<boolean>;
/**
 * Async Filter function
 *
 * @export
 * @template T
 * @param {T[]} elements
 * @param {CallBackFilter<T>} cb
 * @returns {Promise<T[]>}
 */
export declare function filter<T>(elements: T[], cb: CallBackFilter<T>): Promise<T[]>;
