/** returns boolean */
export declare type CallBackFind<T> = (value: T, index?: number, collection?: T[]) => Promise<boolean>;
/**
 * Async Find function
 *
 * @export
 * @template T
 * @param {T[]} elements
 * @param {CallBackFind<T>} cb
 * @returns {(Promise<T | undefined>)}
 */
export declare function find<T>(elements: T[], cb: CallBackFind<T>): Promise<T | undefined>;
