/** returns any type values */
export declare type CallBackMap<T, R> = (value: T, index?: number, collection?: T[]) => Promise<R>;
/**
 * Async Map function
 *
 * @export
 * @template T
 * @template R
 * @param {T[]} elements
 * @param {CallBackMap<T, R>} cb
 * @returns {Promise<R[]>}
 */
export declare function map<T, R>(elements: T[], cb: CallBackMap<T, R>): Promise<R[]>;
