"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Async Map function
 *
 * @export
 * @template T
 * @template R
 * @param {T[]} elements
 * @param {CallBackMap<T, R>} cb
 * @returns {Promise<R[]>}
 */
function map(elements, cb) {
    return __awaiter(this, void 0, void 0, function* () {
        const mappedResults = [];
        for (const [index, element] of elements.entries()) {
            const mappedResult = yield cb(element, index, elements);
            mappedResults.push(mappedResult);
        }
        return mappedResults;
    });
}
exports.map = map;
//# sourceMappingURL=map.js.map