/** returns any type value */
export declare type CallBackReduce<T, R> = (accumulator: R, value: T, index?: number, collection?: T[]) => Promise<R>;
/**
 * Async Reduce function
 *
 * @export
 * @template T
 * @template R
 * @param {T[]} elements
 * @param {CallBackReduce<T, R>} cb
 * @param {R} [initialValue]
 * @returns {Promise<R>}
 */
export declare function reduce<T, R>(elements: T[], cb: CallBackReduce<T, R>, initialValue?: R): Promise<R>;
