"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Async Reduce function
 *
 * @export
 * @template T
 * @template R
 * @param {T[]} elements
 * @param {CallBackReduce<T, R>} cb
 * @param {R} [initialValue]
 * @returns {Promise<R>}
 */
function reduce(elements, cb, initialValue) {
    return __awaiter(this, void 0, void 0, function* () {
        let reducedValue = initialValue;
        for (const [index, element] of elements.entries()) {
            reducedValue = yield cb(reducedValue, element, index, elements);
        }
        return reducedValue;
    });
}
exports.reduce = reduce;
//# sourceMappingURL=reduce.js.map